% This script computes the posterior model probabilities
%
% See:
% Grant, A.L. and Chan, J.C.C. (2017). Measuring the Output Gap Using 
% Stochastic Model Specification Search, CAMA Working Paper 2/2017.

model_count = zeros(2^11,11+1);
for i=1:2^11
    id = de2bi(i-1,11);
    model_count(i,1:11) = id; 
end
for ii=1:nsims
    i = store_del(ii,:)*(2.^(0:10))' + 1;
    model_count(i,end) = model_count(i,end)+1;
end
model_count(:,end) = model_count(:,end)/nsims;
model_count = sortrows(model_count,-12);