% This script initializes the Markov chain for the trivariate UC model
%
% See:
% Grant, A.L. and Chan, J.C.C. (2017). Measuring the Output Gap Using 
% Stochastic Model Specification Search, CAMA Working Paper 2/2017.

rhopi = .7;
rhou = [1.2 -.3]';
rhoc = [1.35 -.7]';
lampi = .5;
lamy = -2;
gampi = .4;
sighc2 = .1;
sighpi2 = .1;
sigu2 = .1;
sigystar = .5;
sigpistar2 = .05;
sigustar2 = .01;
siga = .1;
hpi = log(var(pi))*ones(T,1);
hc = log(var(y))*ones(T,1);
hu = log(var(u))*ones(T,1);
ustar = 6*ones(T,1);
pistar = 5*ones(T,1);
ystar = y;
ystar0 = y(1);
a0 = .6;
nuc = 5;
nupi = 5;
zc = 1./gamrnd(nuc/2,2/nuc,T,1);
zpi = 1./gamrnd(nupi/2,2/nupi,T,1);
del = [1 1 1 1 1 1 0 0]';
H = speye(T) - sparse(2:T,1:T-1,ones(1,T-1),T,T);
H2 = H^2;
Hrhopi = speye(T) - rhopi*sparse(2:T,1:T-1,ones(1,T-1),T,T);
Hrhou = speye(T) - rhou(1)*sparse(2:T,1:T-1,ones(1,T-1),T,T) ...
    - rhou(2)*sparse(3:T,1:T-2,ones(1,T-2),T,T);
Hrhoc = speye(T) - rhoc(1)*sparse(2:T,1:T-1,ones(1,T-1),T,T) ...
    - rhoc(2)*sparse(3:T,1:T-2,ones(1,T-2),T,T);
HH = H'*H;
atilde = chol(HH,'lower')'\randn(T,1);
iSpi = sparse(1:T,1:T,1./(exp(hpi).*zpi));
iSc = sparse(1:T,1:T,1./(exp(hc).*zc));