% This script evaluates the joint distribution of del_a0, del_ystar, del_a,
% del_d1, del_d2
%
% See:
% Grant, A.L. and Chan, J.C.C. (2017). Measuring the Output Gap Using 
% Stochastic Model Specification Search, CAMA Working Paper 2/2017.

function lden = lpost_del_trend(del,pi,y,u,pistar,ystartilde,ustar,...
    atilde,lamy,gamu,lamu,Hrhoc,Hrhopi,iSc,iSpi,Dtilde,prior)
T = size(y,1);
ystar00 = prior(1);
a00 = prior(2);
d0 = prior(3:4)';
Vystar0 = prior(5);
Va0 = prior(6);
Vsigystar = prior(7);
Vsiga = prior(8);
Vd = prior(9:10)';
p = prior(11:end)';
Xys = [ones(T,1) (1:T)'*del(4) ystartilde*del(5) cumsum(atilde)*del(6) ...
    Dtilde(:,1)*del(7) Dtilde(:,2)*del(8)];
HrhociScHrhoc = Hrhoc'*iSc*Hrhoc;
XiSpi = Xys'*iSpi;
K_betays = diag([1/Vystar0 1/Va0 1/Vsigystar 1/Vsiga 1./Vd']) ...
    + Xys'*HrhociScHrhoc*Xys + (del(3)*lamy)^2*XiSpi*Xys;
CK_betays = chol(K_betays,'lower');
betays_hat = CK_betays'\(CK_betays\([ystar00/Vystar0 a00/Va0 0 0 d0'./Vd']'...
    + Xys'*HrhociScHrhoc*(y-del(2)*gamu*(u-ustar)) - del(3)*lamy*XiSpi...
    *(Hrhopi*(pi-pistar)-del(1)*lamu*(u-ustar)-del(3)*lamy*y))); 
lden = -sum(log(diag(chol(K_betays)))) + .5*betays_hat'*K_betays*betays_hat ...
    + sum(del(4:8).*log(p(4:8))+(1-del(4:8)).*log(1-p(4:8)));
end



