% This script samples sample del_zpi, del_zc, del_zu
%
% See:
% Grant, A.L. and Chan, J.C.C. (2017). Measuring the Output Gap Using 
% Stochastic Model Specification Search, CAMA Working Paper 2/2017.

s2_c = (Hrhoc*(y-ystar-del(2)*gamu*(u-ustar))).^2;
s2_pi = (Hrhopi*(pi-pistar)-del(1)*lamu*(u-ustar)-del(3)*lamy*(y-ystar)).^2;
s2_u = (Hrhou*(u-ustar)).^2;

    % sample del_zpi
lp_del_zpi = zeros(2,1);
lp_del_zpi(1) = -T/2*log(2*3.14159)-.5*sum(hpi)-.5*sum(s2_pi./exp(hpi))+log(1-p(9));
lp_del_zpi(2) = T*gammaln((nupi+1)/2)-T*gammaln(nupi/2)-T/2*log(nupi*3.14159)...
    -.5*sum(hpi)-(nupi+1)/2*sum(log(1+s2_pi./exp(hpi)/nupi)) + log(p(9));
p_del_zpi = exp(lp_del_zpi-max(lp_del_zpi));
p_del_zpi = p_del_zpi/sum(p_del_zpi);
del(9) = p_del_zpi(2)>rand;

    % sample del_zc
lp_del_zc = zeros(2,1);
lp_del_zc(1) = -T/2*log(2*3.14159)-.5*sum(hc)-.5*sum(s2_c./exp(hc))+log(1-p(10));
lp_del_zc(2) = T*gammaln((nuc+1)/2)-T*gammaln(nuc/2)-T/2*log(nuc*3.14159)...
    -.5*sum(hc)-(nuc+1)/2*sum(log(1+s2_c./exp(hc)/nuc))+log(p(10));
p_del_zc = exp(lp_del_zc-max(lp_del_zc));
p_del_zc = p_del_zc/sum(p_del_zc);
del(10) = p_del_zc(2)>rand;

    % sample del_u
lp_del_zu = zeros(2,1);
lp_del_zu(1) = -T/2*log(2*3.14159)-.5*sum(hu)-.5*sum(s2_u./exp(hu))+log(1-p(11));
lp_del_zu(2) = T*gammaln((nuu+1)/2)-T*gammaln(nuu/2)-T/2*log(nuu*3.14159)...
    -.5*sum(hu)-(nuu+1)/2*sum(log(1+s2_u./exp(hu)/nuu))+log(p(11));
p_del_zu = exp(lp_del_zu-max(lp_del_zu));
p_del_zu = p_del_zu/sum(p_del_zu);
del(11) = p_del_zu(2)>rand;
    
 