% This script samples del_a0, del_ystar, del_a, del_d1, del_d2
%
% See:
% Grant, A.L. and Chan, J.C.C. (2017). Measuring the Output Gap Using 
% Stochastic Model Specification Search, CAMA Working Paper 2/2017.

bin_table = zeros(2^5,5+1); 
for i=1:2^5
    del_cand = de2bi(i-1,5);
    bin_table(i,1:5) = del_cand;
    bin_table(i,6) = lpost_del_trend([del(1:3)' del_cand]', ...
        pi,y,u,pistar,ystartilde,ustar,atilde,lamy,gamu,lamu,...
        Hrhoc,Hrhopi,iSc,iSpi,Dtilde,[ystar00 a00 d0' Vystar0 Va0 Vsigystar Vsiga Vd' p']);    
end
prob = exp(bin_table(:,end)-max(bin_table(:,end)));
prob = prob/sum(prob);
id_draw = find(cumsum(prob)>rand,1);
del(4:8) = bin_table(id_draw,1:5)';