% This script samples del_lam_u, del_gam_u, del_lam_y
%
% See:
% Grant, A.L. and Chan, J.C.C. (2017). Measuring the Output Gap Using 
% Stochastic Model Specification Search, CAMA Working Paper 2/2017.

bin_table = zeros(2^3,3+1); 
for i=1:2^3
    del_cand = de2bi(i-1,3);
    bin_table(i,1:3) = del_cand;
    bin_table(i,4) = lpost_del_var(del_cand,pi,y,u,pistar,ystar,ustar,Hrhoc,...
        iSc,iSpi,[lamu0 gamu0 lamy0 rhopi0 Vlamu Vgamu Vlamy Vrhopi p(1:3)']); 
    
end
prob = exp(bin_table(:,4)-max(bin_table(:,4)));
prob = prob/sum(prob);
id_draw = find(cumsum(prob)>rand,1);
del(1:3) = bin_table(id_draw,1:3)';